--[[
@name Skillet TSM plugin.
@author Rustam SecondFry Gubaydullin [https://twitch.tv/second_fry]

The MIT License Copyright (c) 2020 Rustam SecondFry Gubaydullin

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES
OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
OR OTHER DEALINGS IN THE SOFTWARE.
]]--

local function NOSORT(tradeskill, a, b)
  return (a.skillIndex or 0) < (b.skillIndex or 0)
end

local function get_suffix(recipe, first)
  local ret = recipe.suffix
  if not ret and recipe.recipeData then
    ret = recipe.recipeData.suffix
  end

  if first and ret == nil and recipe.recipeID then
    actualRecipe = Skillet:GetRecipe(recipe.recipeID)
    Skillet:RecipeNameSuffix(tradeskill, actualRecipe)
    ret = get_suffix(actualRecipe, false)
  end

  return ret
end

local function sort_recipe_by_suffix(tradeskill, a, b)
  if a.subGroup or b.subGroup then
    return NOSORT(tradeskill, a, b)
  end

  local as = get_suffix(a, true)
  local bs = get_suffix(b, true)

  if as == bs then
    return (a.skillIndex or 0) < (b.skillIndex or 0)
  else
    return (as or 0) > (bs or 0)
  end
end

Skillet:AddRecipeSorter("By Suffix", sort_recipe_by_suffix)
